//****************************************************************************************************************************************************
/*==================================================================================================================================================
* mmcsd_init(void)  :must called before any function that work whit mmc
* ==================================================================================================================================================
* mmcsd_write_bytes(uint32_t byte_address,uint32_t length,uint8_t *data_transfer)
* in tabe tedad length byte az array data_transfer ra dar address byte_address mmc copy mikonad
* ==================================================================================================================================================
* mmcsd_read_bytes(uint32_t byte_address,uint32_t length,uint8_t *data_reciver)
* in tabe tedad length byte az address shoroe byte_address mmc copy bardashte va dar array data_reciver gharar midahad
====================================================================================================================================================
* mmcsd_write_sector(uint32_t sector_address,uint16_t sector_offset,uint32_t length,uint8_t *data_transfer)
* in tabe tedade length byte az array data_transfer ra dar sector sector_address va az byte sector_offset an sector copy mikonad
====================================================================================================================================================
*mmcsd_read_sector(uint32_t sector_address,uint16_t sector_offset,uint32_t length,uint8_t *data_reciver)
*in tabe tedade length byte az  sector sector_address va az byte sector_offset an sector dar array  data_reciver  copy mikonad
====================================================================================================================================================
 * hamvare be yad darim ke :dorost ast ke mmc ba yek block be tool 512 ya haman sector kar mikond ama be hangame daryafte address sector bayad
 * an ra be soorate address byte be an dad,.masalan agar mikhahim az sector 400 bekhanim mibayest address 400*512 ra be tabe khandan beferestim
 * =================================================================================================================================================
//***************************************************************************************************************************************************/
//-------------------------------------------------------------------------------------------
#ifndef            _MMCSD_H_
#define            _MMCSD_H_
#include "delay.h"
#include "lpc17xx_spi.h"
//******************************************************************
#ifndef mmc_cs_port
#define mmc_cs_port 0
#endif
#ifndef mmc_cs_pin
#define mmc_cs_pin 0
#endif
#ifndef MMCSD_BLOCK_LENGTH
#define MMCSD_BLOCK_LENGTH 512
#endif
//******************************************************************
//DEFINE    THE   COMMAND THAT USED IN MMC COMONICATION'S PROTOCOL
//******************************************************************
#define        CMD0                    0      //GO_IDEL_STATE    
#define        CMD1                    1     
#define        CMD9                    9          
#define        CMD10                   10
#define        CMD12                   12
#define        CMD13                   13             
#define        CMD16                   16     
#define        CMD17                   17        
#define        CMD18                   18              
#define        CMD23                   23    
#define        CMD24                   24                                                  
#define        CMD25                   25              
#define        CMD27                   27
#define        CMD28                   28
#define        CMD29                   29
#define        CMD30                   30
#define        CMD35                   35
#define        CMD36                   36      
#define        CMD38                   38
#define        CMD41                   41
#define        CMD42                   42
#define        CMD55                   55
#define        CMD58                   58
#define        CMD59                   59

#define        GO_IDLE_STATE              CMD0
#define        SEND_OP_COND               CMD1
#define        SEND_CSD                   CMD9
#define        SEND_CID                   CMD10
#define        STOP_MULTIPLE_BLOCK_READ   CMD12
#define        SEND_STATUS                CMD13
#define        SET_BLOCKLEN               CMD16
#define        READ_SINGLE_BLOCK          CMD17
#define        READ_MULTIPLE_BLOCK        CMD18
#define        SET_BLOCK_COUNT            CMD23
#define        WRITE_SINGLE_BLOCK         CMD24
#define        WRITE_MULTIPLE_BLOCK       CMD25
#define        PROGRAM_CSD                CMD27
#define        SET_WRITE_PROT             CMD28
#define        CLR_WRITE_PROT             CMD29
#define        SEND_WRITE_PROT            CMD30
#define        ERASE_GROUP_START          CMD35
#define        ERASE_GROUP_END            CMD36
#define        ERASE                      CMD38
#define        SEND_SD_OP_COND            CMD41
#define        LOCK_UNLOCK                CMD42
#define        SD_APP_CMD                 CMD55
#define        CRC_ON_OFF                 CMD59 

#define        READ_SINGLE_BLOCK_TOKEN  		  0xfe
#define        READ_MULTIPLE_BLOCK_TOKEN 		  0xfe
#define        WRITE_SINGLE_BLOCK_TOKEN   		  0xfe
#define        WRITE_MULTIPLE_BLOCK_TOKEN		  0xfc
#define        WRITE_MULTIPLE_BLOCK_STOP_TOKEN    0xfd
//************************************************************************
typedef enum _mmc_error{
mmcsd_good               = 0x00,
in_idle_state          = 0x01,
ereas_reset            = 0x02,
illegal_command        = 0x04,
crc_error              = 0x08,
erase_sequence_error   = 0x10,
address_error          = 0x20,
parameter_error        = 0x40,
RESP_TIMEOUT           = 0x80
} mmc_error;

const unsigned char     crc_for_cmd0  =  0x95;
//************************************************************************
//VARIUBLES THAT WY NEED IN THIS COMONICATION
uint8_t     mmcsd_buffer[MMCSD_BLOCK_LENGTH];
char   string[40];
SPI_DATA_SETUP_Type   spidata;
//************************************************************************
//declare function and sub

//-----------user function---------------------
mmc_error                mmcsd_init(void);
mmc_error                mmcsd_write_bytes(uint32_t byte_address,uint32_t length,uint8_t *data_transfer);
mmc_error                mmcsd_read_bytes(uint32_t byte_address,uint32_t length,uint8_t *data_reciver);
mmc_error                mmcsd_write_sector(uint32_t sector_address,uint16_t sector_offset,uint32_t length,uint8_t *data_transfer);
mmc_error                mmcsd_read_sector(uint32_t sector_address,uint16_t sector_offset,uint32_t length,uint8_t *data_reciver);
//-----------internal function--------------------
mmc_error                mmcsd_send_command(uint8_t command,uint32_t argoment,uint8_t crc);
mmc_error                mmcsd_go_idle_state(void);
mmc_error                mmcsd_send_op_cond(void);
mmc_error                mmcsd_send_if_cond(uint8_t r7[]);
mmc_error                mmcsd_print_csd();
mmc_error                mmcsd_print_cid();
mmc_error                mmcsd_sd_status(uint8_t r2[]);
mmc_error                mmcsd_send_status(uint8_t r2[]);
mmc_error                mmcsd_set_blocklen(uint32_t blocklen);
mmc_error                mmcsd_read_single_block(unsigned long int sector_address);
mmc_error                mmcsd_write_single_block(uint32_t sector_address);
mmc_error                mmcsd_sd_send_op_cond(void);
mmc_error                mmcsd_app_cmd(void);
mmc_error                mmcsd_read_ocr(uint8_t* r1);
mmc_error                mmcsd_crc_on_off(uint8_t crc_enabled);
mmc_error                mmcsd_get_r1(void);

void                     mmc_cs_ready(void);
void                     mmcsd_select(void);
void                     mmcsd_deselect(void);
Bool                     mmcsd_is_busy(void);
//************************************************************************
mmc_error                mmcsd_init(void)
{
   mmc_error error;
   uint16_t i;
   PINSEL_CFG_Type   pincfg;
   SPI_CFG_Type      spicfg;
   PINSEL_CFG_Type PinCfg;
  SPI_CFG_Type SPI_ConfigStruct;
/* Initialize SPI pin connect
    * P0.15 - SCK;
    * P0.16 - SSEL - used as GPIO
    * P0.17 - MISO
    * P0.18 - MOSI*/
   PinCfg.Funcnum = 3;
   PinCfg.OpenDrain = 0;
   PinCfg.Pinmode = 0;
   PinCfg.Portnum = 0;
   PinCfg.Pinnum = 15;
   PINSEL_ConfigPin(&PinCfg);
   PinCfg.Pinnum = 17;
   PINSEL_ConfigPin(&PinCfg);
   PinCfg.Pinnum = 18;
   PINSEL_ConfigPin(&PinCfg);
   PinCfg.Pinnum = 16;
   PinCfg.Funcnum = 0;
   PINSEL_ConfigPin(&PinCfg);

   SPI_ConfigStruct.CPHA = SPI_CPHA_FIRST;
   SPI_ConfigStruct.CPOL = SPI_CPOL_HI;
   SPI_ConfigStruct.ClockRate = 400000;
   SPI_ConfigStruct.DataOrder = SPI_DATA_MSB_FIRST;
   SPI_ConfigStruct.Databit = SPI_DATABIT_8;
   SPI_ConfigStruct.Mode = SPI_MASTER_MODE;
   //SPI_ConfigStructInit(&SPI_ConfigStruct);
   SPI_Init(LPC_SPI, &SPI_ConfigStruct);
   mmcsd_cs_ready();
   
                                                               //strcpy(string,"start initalization mmc");
                                                               //lcd_puts(10,10,string,black,0,yellow,1);
                                                               //delay_ms(1000);
   spidata.tx_data=NULL;
   spidata.rx_data=NULL;
   spidata.length=16;
   SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
                                                               //strcpy(string,"transfer oxFF");
                                                               //lcd_puts(10,26,string,black,0,yellow,1);
                                                               //delay_ms(1000);
   delay_ms(1);
                                                               //strcpy(string,"want to reset mmc");
                                                               // lcd_puts(10,45,string,black,0,yellow,1);
                                                               //delay_ms(1000);
   error=mmcsd_go_idle_state();                                                            
   if(error!=in_idle_state)
   {   
                        
                                                               //sprintf(string,"%s%u","mmc not going to idle state    ",error);
                                                               //lcd_puts(10,65,string,black,0,yellow,1);
                                                               //delay_ms(1000);
      return(error);
   }
   else
   {
                                                               //strcpy(string,"mmc in idle state");
                                                               //lcd_puts(10,65,string,black,0,yellow,1);
                                                               //delay_ms(1000);
   }
   SPI_ConfigStructInit(&SPI_ConfigStruct);
   SPI_Init(LPC_SPI, &SPI_ConfigStruct);
   delay_ms(10);
   
   //-------------------------------mmc or sd-----------------------------------------------------
   error=mmcsd_app_cmd();
   if(error==in_idle_state)					//this card is sd
   {
	   error=mmcsd_sd_send_op_cond();
	   	   	   	   	   	   //strcpy(string,"this card is sd");
   }
   else                                    //this card is mmc
   {
	   error=mmcsd_send_op_cond();
	   	   	   	   	   	   //strcpy(string,"this card is mmc");
   }
   	   	   	   	   	   	   //lcd_puts(10,86,string,black,0,yellow,1);
   //---------------------------------------------------------------------------------------------
      if(error!=mmcsd_good)
      {
                                                                //strcpy(string,"card not exit form idle state");
                                                                //lcd_puts(10,100,string,black,0,yellow,1);
         return(error);
      }
      else
      {
                                                                //strcpy(string,"card exit form idle state");
                                                                //lcd_puts(10,100,string,black,0,yellow,1);
      }
      
      delay_ms(10);

      error=mmcsd_crc_on_off(0);
      if(error!=mmcsd_good)
      {
                                                                //strcpy(string,"mmc crc not off");
                                                               // lcd_puts(10,116,string,black,0,yellow,1);
      return(error);
      }
      else
      {
                                                               //strcpy(string,"mmc crc off");
                                                               // lcd_puts(10,116,string,black,0,yellow,1);
      }

      error=mmcsd_set_blocklen(MMCSD_BLOCK_LENGTH);
      if(error!=mmcsd_good)
      {
                                                               //strcpy(string,"not recpect 512");
                                                               // lcd_puts(10,132,string,black,0,yellow,1);
            return(error);
      }
      else
      {
                                                               //strcpy(string,"mmc respect 512");
                                                               // lcd_puts(10,132,string,black,0,yellow,1);
      }
   return(mmcsd_good);
}
//-----------------------------------------
mmc_error                mmcsd_write_bytes(uint32_t byte_address,uint32_t length,uint8_t *data_transfer)
{
		uint32_t start_sector_address,sector_count;
		uint16_t start_sector_offset,end_sector_offset;
		uint8_t i,j;
		start_sector_address=byte_address/MMCSD_BLOCK_LENGTH;
		start_sector_offset=byte_address%MMCSD_BLOCK_LENGTH;
		mmcsd_read_single_block(start_sector_address);
		if(MMCSD_BLOCK_LENGTH>=(length+start_sector_offset))
		{
			for( i=0 ; i<length ; i++)
				mmcsd_buffer[start_sector_offset++]=*(data_transfer++);
			mmcsd_write_single_block(start_sector_address);
		}
		else
		{
			for( i=start_sector_offset ; i<MMCSD_BLOCK_LENGTH ; i++)
				mmcsd_buffer[start_sector_offset++]=*(data_transfer++);
			mmcsd_write_single_block(start_sector_address++);
			length=length-(MMCSD_BLOCK_LENGTH-start_sector_offset);
			sector_count=length/MMCSD_BLOCK_LENGTH;
			end_sector_offset=length%MMCSD_BLOCK_LENGTH;
			for( j=0 ; j< sector_count ; j++)
			{
				for( i=0 ; i<MMCSD_BLOCK_LENGTH ; i++)
					mmcsd_buffer[i]=*(data_transfer++);
				mmcsd_write_single_block(start_sector_address++);
			}
			mmcsd_read_single_block(start_sector_address);
			for( i=0 ; i<end_sector_offset ; i++)
				mmcsd_buffer[i]=*(data_transfer++);
			mmcsd_write_single_block(start_sector_address);
		}
}
//-----------------------------------------
mmc_error                mmcsd_read_bytes(uint32_t byte_address,uint32_t length,uint8_t *data_reciver)
{
	uint32_t start_sector_address,sector_count;
	uint16_t start_sector_offset,end_sector_offset;
	uint8_t i,j;
	start_sector_address=byte_address/MMCSD_BLOCK_LENGTH;
	start_sector_offset=byte_address%MMCSD_BLOCK_LENGTH;
	mmcsd_read_single_block(start_sector_address);
	if(MMCSD_BLOCK_LENGTH>=(length+start_sector_offset))
	{
		for( i=0 ; i<length ; i++)
			*(data_reciver++)=mmcsd_buffer[start_sector_offset++];
	}
	else
	{
		for( i=start_sector_offset ; i<MMCSD_BLOCK_LENGTH ; i++)
			*(data_reciver++)=mmcsd_buffer[start_sector_offset++];
		length=length-(MMCSD_BLOCK_LENGTH-start_sector_offset);
		sector_count=length/MMCSD_BLOCK_LENGTH;
		end_sector_offset=length%MMCSD_BLOCK_LENGTH;
		for( j=0 ; j< sector_count ; j++)
		{
			mmcsd_read_single_block(start_sector_address++);
			for( i=0 ; i<MMCSD_BLOCK_LENGTH ; i++)
						*(data_reciver++)=mmcsd_buffer[i];
		}
		mmcsd_read_single_block(start_sector_address);
		for( i=0 ; i<end_sector_offset ; i++)
				*(data_reciver++)=mmcsd_buffer[i];
	}
}
//------------------------------------------
mmc_error                mmcsd_write_sector(uint32_t sector_address,uint16_t sector_offset,uint32_t length,uint8_t *data_transfer)
{
	uint16_t i;
		mmcsd_read_single_block(sector_address);
		for(i=0;i<length;i++)
			mmcsd_buffer[sector_offset++]=*(data_transfer++);
		mmcsd_write_single_block(sector_address);
}
//-------------------------------------------
mmc_error                mmcsd_read_sector(uint32_t sector_address,uint16_t sector_offset,uint32_t length,uint8_t *data_reciver)
{
	uint16_t i;
	mmcsd_read_single_block(sector_address);
	for(i=0;i<length;i++)
		*(data_reciver++)=mmcsd_buffer[sector_offset++];

}
//------------------------------------------
mmc_error                mmcsd_go_idle_state(void)
{
   uint8_t i;
   mmc_error r1=RESP_TIMEOUT;
   //delay_us(10);
   for(i=0;i<200;i++)
   {
	   mmcsd_select();
	  r1=mmcsd_send_command(GO_IDLE_STATE,0x00000000,0x95);
	  mmcsd_deselect();
      if(r1==in_idle_state)
         break;
   }
   return(r1);
}
//-----------------------------------------
mmc_error                mmcsd_send_op_cond(void)
{
   uint16_t i;
   mmc_error r1;
   for(i=0;i<50000;i++)
   {
      mmcsd_select();
      //delay_us(10);
      r1=mmcsd_send_command(SEND_OP_COND,0x00000000,0xff);
      mmcsd_deselect();
      if(r1==mmcsd_good)
         break;
   }
   return r1;
}
//-----------------------------------------
mmc_error                mmcsd_send_if_cond(uint8_t r7[]);
mmc_error                mmcsd_print_csd();
mmc_error                mmcsd_print_cid();
mmc_error                mmcsd_sd_status(uint8_t r2[]);
mmc_error                mmcsd_send_status(uint8_t r2[]);
//------------------------------------------
mmc_error                mmcsd_set_blocklen(uint32_t blocklen)
{
	mmc_error r1;
	mmcsd_select();
    //delay_us(10);
	r1=mmcsd_send_command(SET_BLOCKLEN, 512,0xff);
	mmcsd_deselect();
	return r1;
}
//------------------------------------------
mmc_error                mmcsd_read_single_block(unsigned long int sector_address)
{
	mmc_error error;
	uint8_t reciver_buffer[2];
	error=mmcsd_good;
	mmcsd_select();
	delay_us(100);
	if(error=mmcsd_send_command(READ_SINGLE_BLOCK,sector_address*MMCSD_BLOCK_LENGTH,0xff),error==mmcsd_good)
	{
			spidata.tx_data=NULL;
			spidata.rx_data=reciver_buffer;
			spidata.length=1;
			while(1){
				SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
				if(reciver_buffer[0]==READ_SINGLE_BLOCK_TOKEN)
					break;
			}
			spidata.tx_data=NULL;
			spidata.rx_data=mmcsd_buffer;
			spidata.length=MMCSD_BLOCK_LENGTH;
			SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
			spidata.tx_data=NULL;
			spidata.rx_data=NULL;
			spidata.length=2;
			SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
	}
	mmcsd_deselect();
	return error;

}
//----------------------------------------
mmc_error                mmcsd_write_single_block(uint32_t sector_address)
{
	mmc_error error,r1;
	uint16_t i;
	uint8_t transfer_buffer[2];
	uint8_t reciver_buffer[2];
	error=mmcsd_good;
	mmcsd_select();
	if(error=mmcsd_send_command(WRITE_SINGLE_BLOCK,sector_address*MMCSD_BLOCK_LENGTH,0xff),error==mmcsd_good)
	{
				spidata.tx_data=NULL;
				spidata.rx_data=NULL;
				spidata.length=5;
				SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
				transfer_buffer[0]=WRITE_SINGLE_BLOCK_TOKEN;
				spidata.tx_data=transfer_buffer;
				spidata.rx_data=NULL;
				spidata.length=1;
				SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
				spidata.tx_data=mmcsd_buffer;
				spidata.rx_data=NULL;
				spidata.length=MMCSD_BLOCK_LENGTH;
				SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
				spidata.tx_data=NULL;
				spidata.rx_data=NULL;
				spidata.length=2;
				SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
				spidata.tx_data=NULL;
				spidata.rx_data=reciver_buffer;
				spidata.length=1;
				SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
				if((reciver_buffer[0]&0x1f)==0x05)
				{
					error=mmcsd_good;
				}
				else
					error=in_idle_state;
				mmcsd_is_busy();
				mmcsd_deselect();
	}
	mmcsd_deselect();
	return error;
}
//------------------------------------------
mmc_error                mmcsd_app_cmd(void)
{
	mmc_error r1;
	mmcsd_select();
	r1=mmcsd_send_command(SD_APP_CMD, 0x00000000,0xff);
	mmcsd_deselect();
	return r1;
}
//-----------------------------------------
mmc_error                mmcsd_sd_send_op_cond(void)
{
	uint16_t i;
	   mmc_error r1;
	   for(i=0;i<50000;i++)
	   {
		  r1=mmcsd_app_cmd();
	      mmcsd_select();
	      r1=mmcsd_send_command(SEND_SD_OP_COND,0x00000000,0xff);
	      mmcsd_deselect();
	      if(r1==mmcsd_good)
	         break;
	   }
	   return r1;
}
//----------------------------------------

mmc_error                mmcsd_read_ocr(uint8_t* r1);
//-----------------------------------------
mmc_error                mmcsd_crc_on_off(uint8_t crc_enabled)
{
   mmc_error r1;
   mmcsd_select();
   delay_us(10);
   r1=mmcsd_send_command(CRC_ON_OFF, crc_enabled,0xff);
   mmcsd_deselect();
   return r1;
}

//-------------------------------------------
void                     mmcsd_cs_ready(void)
{
   GPIO_SetDir(mmc_cs_port,1<<mmc_cs_pin,1);
   GPIO_SetValue(mmc_cs_port,1<<mmc_cs_pin);
}
//-------------------------------------------
void                     mmcsd_select(void)
{
   GPIO_ClearValue(mmc_cs_port,1<<mmc_cs_pin);
}
//--------------------------------------------
void                     mmcsd_deselect(void)
{
   GPIO_SetValue(mmc_cs_port,1<<mmc_cs_pin);
}
//--------------------------------------------
Bool                     mmcsd_is_busy(void)
{
		   mmc_error error=RESP_TIMEOUT;
		   uint8_t reciver_buffer[2];
		   uint8_t i;
		   spidata.tx_data=NULL;
		   spidata.rx_data=reciver_buffer;
		   spidata.length=1;
		   do{
			   SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);

		   }while(reciver_buffer[0]!=0xff);
}
//------------------------------------------------------------------------
mmc_error                mmcsd_send_command(unsigned char command,unsigned long int argoment,unsigned char crc)
{
	unsigned char transfer_buffer[7];
   command|=0x40;
   transfer_buffer[0]=command;
   transfer_buffer[1]=(unsigned char)(argoment>>24);
   transfer_buffer[2]=(unsigned char)(argoment>>16);
   transfer_buffer[3]=(unsigned char)(argoment>>8);
   transfer_buffer[4]=(unsigned char)(argoment);
   transfer_buffer[5]=crc;
   spidata.tx_data=transfer_buffer;
   spidata.rx_data=NULL;
   spidata.length=6;
   SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
   return mmcsd_get_r1();
}
//------------------------------------------
mmc_error                mmcsd_get_r1(void)
{
		mmc_error error=RESP_TIMEOUT;
		uint8_t reciver_buffer[2];
		uint8_t i;
	   spidata.tx_data=NULL;
	   spidata.rx_data=reciver_buffer;
	   spidata.length=1;
	   for(i=0;i<100;i++)
	   {
		   SPI_ReadWrite(LPC_SPI,&spidata,SPI_TRANSFER_POLLING);
		   if(reciver_buffer[0]!=0xff)
			   return reciver_buffer[0];

	   }
	   return error;
}
//------------------------------------------------------------------------
#endif
